#####
## SPINN DESIGN CODE
# YOUTUBE: (SPINN TV) https://www.youtube.com/spinnTv
# WEBSITE: spinndesign.com
########################################################################

########################################################################
## IMPORTS
########################################################################
import os
import sys


from PyQt5.QtWidgets import QMainWindow, QWidget, QApplication
from PyQt5.QtGui import QFont, QFontDatabase

################################################################################################
# Convert UI to PyQt5 py file
################################################################################################
os.system("pyuic5 -o interface_ui.py interface.ui")

################################################################################################
# Import UI file
################################################################################################

from interface_ui import *


################################################################################################
# MAIN WINDOW CLASS
################################################################################################
class MainWindow(QMainWindow):
    def __init__(self, parent=None):
        QMainWindow.__init__(self)
        ################################################################################################
        # Setup the UI main window
        ################################################################################################
        self.ui = Ui_MainWindow()
        self.ui.setupUi(self)
        

        ################################################################################################
        # Show window
        ################################################################################################
        self.show()

        ################################################################################################
        # CUSTOMIZE ANALOGUE GAUGE WIDGET
        ################################################################################################
        # self.ui.widget.enableBarGraph = True

        ################################################################################################
        # Set gauge units
        ################################################################################################
        # self.ui.widget.units = "Mph"

        ################################################################################################
        # Set minimum gauge value
        ################################################################################################
        # self.ui.widget.minValue = 100

        ################################################################################################
        # Set maximum gauge value
        ################################################################################################
        # self.ui.widget.maxValue = 500

        ################################################################################################
        # Set scale divisions
        ################################################################################################
        # self.ui.widget.scalaCount = 10

        # Start from the minimum value
        # self.ui.widget.updateValue(self.ui.widget.minValue)
        # OR
        # Start from half/middle value
        # self.ui.widget.updateValue(int(self.ui.widget.maxValue - self.ui.widget.minValue)/2)

        ################################################################################################
        # Select gauge theme
        ################################################################################################
        # 0 to 24
        # self.ui.widget.setGaugeTheme(20)

        # self.ui.widget.setCustomGaugeTheme(
        #     color1 = "#FF00A6", #bright
        #     color2= "#870058", #middle brightness
        #     color3 = "#360023" #darkest
        # )

        # self.ui.widget.setCustomGaugeTheme(
        #     color1 = "#360023", #darkest
        #     color2= "#870058", #middle brightness
        #     color3 = "#FF00A6" #bright
        # )

        # self.ui.widget.setCustomGaugeTheme(
        #     color1 = "#002523",
        #     color2= "#990008",
        #     color3 = "#00F6E9"
        # )

        # self.ui.widget.setCustomGaugeTheme(
        #     color1 = "#00F6E9",
        #     color2= "#990008",
        #     color3 = "#002523"
        # )

        # self.ui.widget.setCustomGaugeTheme(
        #     color1 = "#fff", #white
        #     color2= "#555", #grey
        #     color3 = "#000" #black
        # )

        # self.ui.widget.setCustomGaugeTheme(
        #     color1 = "#000", #black
        #     color2= "#555", #grey
        #     color3 = "#fff" #white
        # )

        # self.ui.widget.setCustomGaugeTheme(
        #     color1 = "orange",
        #     color2 = "blue"
        # )

        # self.ui.widget.setScalePolygonColor(
        #     color1 = "white",
        #     color2 = "#C1007D",
        #     color3 = "green"
        # )

        # self.ui.widget.setNeedleCenterColor(
        #     color1 = "white",
        #     color2 = "#C1007D",
        #     color3 = "green"
        # )

        # self.ui.widget.setOuterCircleColor(
        #     color1 = "#22FF00",
        #     color2 = "#000",
        #     color3 = "#021200"
        # )

        # self.ui.widget.setBigScaleColor("red")
        # self.ui.widget.setFineScaleColor("white")

        ################################################################################################
        # Set custom font
        ################################################################################################
        # QFontDatabase.addApplicationFont(os.path.join(os.path.dirname(__file__), 'fonts/ds_digital/DS-DIGIB.TTF') )

        # self.ui.widget.setValueFontFamily("DS-Digital")
        # self.ui.widget.setScaleFontFamily("DS-Digital")

        # self.ui.widget.setNeedleColor(34, 255, 0, 255)
        # self.ui.widget.setNeedleColorOnDrag(34, 255, 0, 255)
        # self.ui.widget.setScaleValueColor(34, 255, 0, 255)
        # self.ui.widget.setDisplayValueColor(34, 255, 0, 255)


        # self.ui.widget.setEnableBarGraph(False)
        # self.ui.widget.setEnableValueText(False)
        # self.ui.widget.setEnableCenterPoint(True)
        # self.ui.widget.setEnableNeedlePolygon(False)
        # self.ui.widget.setEnableScaleText(False)
        # self.ui.widget.setEnableScalePolygon(False)
        # self.ui.widget.setEnableBigScaleGrid(True)
        # self.ui.widget.setEnableFineScaleGrid(True)

        # self.ui.widget.setMouseTracking(False)


########################################################################
## EXECUTE APP
########################################################################
if __name__ == '__main__':
    app = QApplication(sys.argv)
    ########################################################################
    ## 
    ########################################################################
    window = MainWindow()
    window.show()
    sys.exit(app.exec_())

########################################################################
## END===>
########################################################################  